cls
@echo off
setlocal enabledelayedexpansion
color 0A

echo.
echo *********************************
echo ***** Welcome to c't-wimage *****
echo *********************************
echo.

rem Need help?
if /i "%1"=="/?" goto ct_help
if /i "%1"=="-?" goto ct_help
if /i "%1"=="/h" goto ct_help
if /i "%1"=="-h" goto ct_help
if /i "%1"=="--h" goto ct_help
if /i "%1"=="/help" goto ct_help
if /i "%1"=="-help" goto ct_help
if /i "%1"=="--help" goto ct_help

echo *** Some tests in advance ... ***
echo.

set operation=*** Script needs at least Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto ct_error1

set operation=*** This script is for 64-bit Windows only ***
if not exist "%ProgramFiles(x86)%" goto ct_error1

set operation=*** Script must run with administrator rights ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto ct_error1

set operation=*** Datapartition on current disk ***
set usbdata=%~d0

set operation=*** Installation files should be on data partition ***
if not exist %usbdata%\sources goto ct_error1
if not exist %usbdata%\setup.exe goto ct_error1

set operation=*** 64-bit installation files are needed ***
if not exist %usbdata%\efi\boot\bootx64.efi goto ct_error1

set operation=*** Scan bootpartition ***
rem On which partition is the current logical disk?
set partition=
wmic LogicalDisk where (DeviceID="%usbdata%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto ct_bootinput
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set partition=%%P
  )
)
if "%partition%"=="" goto ct_bootinput
rem On which fysical disk is this partition?
set drive=
wmic Partition where (DeviceID="%partition%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto ct_bootinput
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-24!"=="Win32_DiskDrive.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set drive=%%P
  )
)
if "%drive%"=="" goto ct_bootinput
rem What other partitions are there on this disk?
set otherpart=
set bootpart=
wmic DiskDrive where (DeviceID="%drive%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto ct_bootinput
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherpart=%%P
    if not "!otherpart!"=="%partition%" (
      if "!bootpart!"=="" (
        set bootpart=!otherpart!
      ) else (
        set bootpart=undefined
      )
    )
  )
)
if "%bootpart%"=="undefined" goto ct_bootinput
if "%bootpart%"=="" goto ct_bootinput
rem What logical disk is in this partition?
set otherdisk=
set usbboot=
wmic Partition where (DeviceID="%bootpart%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto ct_bootinput
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-26!"=="Win32_LogicalDisk.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherdisk=%%P
    if "!usbboot!"=="" (
      set usbboot=!otherdisk!
    ) else (
      set usbboot=undefined
    )
  )
)
if "%usbboot%"=="undefined" goto ct_bootinput
if "%usbboot%"=="" goto ct_bootinput
goto ct_continue1

:ct_bootinput
echo "Boot partition not (or not unambiguously) determinable"
set /p usbboot=Drive letter of partition USB-Boot64:
if "%usbboot%"=="" goto ct_error2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

:ct_continue1
echo.
echo Drive letter of partition USB-Boot64: %usbboot%
echo Drive letter of partition USB-Data64: %usbdata%
choice /m "OK "
if not errorlevel 2 goto ct_continue2

set /p usbboot=Drive letter of partition USB-Boot64:
if "%usbboot%"=="" goto ct_error2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

set /p usbdata=Drive letter of partition USB-Data64:
if "%usbdata%"=="" goto ct_error2
if "%usbdata:~-1%"=="\" set usbdata=%usbdata:~0,-1%
if not "%usbdata:~-1%"==":" set usbdata=%usbdata%:

:ct_continue2
set operation=*** There should be a bcd-store on the selected partition ***
if not exist %usbboot%\boot\bcd goto ct_error1
if not exist %usbboot%\efi\microsoft\boot\bcd goto ct_error1

set operation=*** You can not select the bootloader of the current Windows ***
bcdedit /store %usbboot%\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto ct_error1
if %errorlevel% equ 0 goto ct_error1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto ct_error1
if %errorlevel% equ 0 goto ct_error1

set operation=*** You should select the bootloader of a Windows PE/RE ***
bcdedit /store %usbboot%\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto ct_error1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto ct_error1

set operation=*** Adapt bootloader ***
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} device ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto ct_error2
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} osdevice ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto ct_error2
bcdedit /store %usbboot%\boot\bcd /set {default} device ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto ct_error2
bcdedit /store %usbboot%\boot\bcd /set {default} osdevice ramdisk=[%usbdata%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto ct_error2

set operation=*** Adapt ei.cfg ***
echo [EditionID] > %usbdata%\sources\ei.cfg
if errorlevel 1 goto ct_error2
echo. >> %usbdata%\sources\ei.cfg
echo [Channel] >> %usbdata%\sources\ei.cfg
echo OEM >> %usbdata%\sources\ei.cfg
echo. >> %usbdata%\sources\ei.cfg
echo [VL] >> %usbdata%\sources\ei.cfg
echo 0 >> %usbdata%\sources\ei.cfg
if errorlevel 1 goto ct_error2

echo Ready!
pause
goto :eof

rem Requirements not met
:ct_error1
set text=The next requirement is not met: 
goto ct_showerror

rem ct_error during execution
:ct_error2
set text=Execution failed:
goto ct_showerror

:ct_showerror
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
pause
goto :eof

:ct_help
echo.
echo %~nx0 bends the bootloader oo the partition USB-Boot64
echo in order to start setup.exe from the partition USB-Data64
echo. 
echo %~nx0 should be run with administrator rights!
echo.
pause>nul
goto :eof
;
REM Made by Axel Vahldiek and Hajo Schulz (c't) 2014-2018 / Noud van Kruysbergen
REM mailto: nkr@ct.nl