cls
@echo off
setlocal enabledelayedexpansion
color 0A

set advice=Please read the guidelines in this script

rem --------- Optional: change at will -----------

rem When the script should shutdown Windows after creating the image,
rem then change the variable shutdown from 0 to 1

set Shutdown=0

rem Set path to directory for the script itself, vshadow.exe and the 
rem reset-image setzen, for example d:\resetimage\
rem Without adjustments, the script uses the directory in which it is located
rem No spaces in the path and end with "\"!

set workdir=%~d0%~p0

rem --------- Optional: extra adjustments only for Windows 8.1 -----------

rem This script can set the last created image as recovery image
rem It will be restored when you select "Remove everything and install new Windows"
rem at Update/Restore. If you want that, then change the value of Reset from 0 to 1
rem THIS OPTION ONLY WORKS WITH WINDOWS 8.1

set Reset=0

rem This script can set the last created image as refresh image
rem It will be refreshed when you select "Refresh Windows without destroying files"
rem at Update/Restore. If you want that, then change the value of Refresh from 0 to 1
rem It will create another image, so will cost extra space at the target medium
rem THIS OPTION ONLY WORKS WITH WINDOWS 8.1

set Refresh=0

rem ------------- End of adjustments -----------

echo.
echo ********************************
echo *** Welcome to c't-wimage v2 ***
echo ********************************
echo.
echo %Advice%
echo.

set description=
set operation=*** Check commandline parameters ***
:parseargs
if "%1"=="" goto endargs
rem Help needed?
if /i "%1"=="/?" goto ct_help
if /i "%1"=="-?" goto ct_help
if /i "%1"=="/h" goto ct_help
if /i "%1"=="-h" goto ct_help
if /i "%1"=="--h" goto ct_help
if /i "%1"=="/help" goto ct_help
if /i "%1"=="-help" goto ct_help
if /i "%1"=="--help" goto ct_help
rem Description needed for the image?
set option=0
if /i "%1"=="/d" set option=1
if /i "%1"=="-d" set option=1
if %option%==1 (
  set description="%~2"
  shift /1
  shift /1
  goto parseargs
)
rem Set image as restore image?
if /i "%1"=="/reset" set option=1
if /i "%1"=="-reset" set option=1
if %option%==1 (
  set Reset=1
  shift /1
  goto parseargs
)
rem Set image as refresh image?
if /i "%1"=="/refresh" set option=1
if /i "%1"=="-refresh" set option=1
if %option%==1 (
  set Refresh=1
  shift /1
  goto parseargs
)
rem Shutdown after backup?
if /i "%1"=="/s" set option=1
if /i "%1"=="-s" set option=1
if /i "%1"=="/shutdown" set option=1
if /i "%1"=="-shutdown" set option=1
if %option%==1 (
  set Shutdown=1
  shift /1
  goto parseargs
)
color 0C
echo *** Unknown commandline parameter: %1 ***
echo.
goto ct_help
:endargs

echo *** Some tests in advance ... ***
echo.

set operation=*** Script needs at least Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto ct_error1

set operation=*** Deactivate reset and refresh for Windows 10 ***
for /f "tokens=4" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"ProductName^"') do set version=%%a
if errorlevel 1 goto ct_error1
if not "%version%" == "8.1" (
  set Reset=0
  set Refresh=0
)

set operation=*** This script is for 64-bit Windows only ***
if not exist "%ProgramFiles(x86)%" goto ct_error1

set operation=*** Script must run with administrator rights ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto ct_error1

set operation=*** Working directory can not be on Windows-drive ***
if %~d0 equ %systemdrive% goto ct_error1

set operation=*** vshadow.exe should be in working directory ***
set vshadow=vshadow64.exe
if not exist %workdir%%vshadow% goto ct_error1

set operation=*** Directory "Sources" should be in working directory ***
if not exist %workdir%sources goto ct_error1

set operation=*** There should be less than 1000 images in install.wim ***
set action=append-image 
if not exist %workdir%sources\install.wim (
  set action=capture-image /compress:max
) else (
  set lastnumber=1
  for /f "tokens=1,2* delims=: " %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim') do (
    if "%%L"=="Index" set /a lastnumber=%%M
  )
  if !lastnumber! gtr 1000 goto ct_error1
)

set operation=*** c't-WIMage des not work when the Linux subsystem (WSL) is installed ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentbuild^"') do set /a build=%%a
if %build% geq 16299 dism /online /english /get-featureinfo /featurename:Microsoft-Windows-Subsystem-Linux | findstr "Disabled" > nul
if errorlevel 1 goto ct_error2

echo *** No problems found, here we go ***
echo.

echo *** Preparing ... ***
set operation=*** Add RunOnce key to restore WinRE ***
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /f /v "enablewinre" /d "reagentc /enable" >nul 2>nul
if errorlevel 1 goto ct_error2

set operation=*** Move Windows RE to Windows partition ***
reagentc /disable >nul 2>nul
if errorlevel 1 goto ct_error2

set operation=*** Search free drive letter for shadow copy ***
echo.
echo %operation%
for %%l in (P Q R S T U V W X Y Z D E F G H I J K L M N O) do (  
  set sklw=%%l
  mountvol %%l: /L >nul
  if errorlevel 1 (
    subst | findstr /B "%%l:" >nul
    if errorlevel 1 (
      net use %%l: >nul 2>&1
      if errorlevel 1 goto ct_continu
    )
  )
)
goto ct_error2
:ct_continu
echo Use %sklw%:

echo.
set operation=*** Create shadow copy of Windows partition ***
echo.
echo %operation%
%workdir%%vshadow% -p -script=%workdir%vshadowtemp.cmd %systemdrive% >nul 2>nul
if errorlevel 1 goto ct_error2
call %workdir%vshadowtemp.cmd >nul 2>nul
if errorlevel 1 goto ct_error2
%workdir%%vshadow% -el=%SHADOW_ID_1%,%sklw%:
if errorlevel 1 goto ct_error2

echo.
echo.
set operation=*** Create/expand image ***
echo %operation%
echo.
echo It can take a while for the progress bar appears
echo After reaching the 100 percent, it can take a while again
echo. 
for /f  "tokens=4 delims=] " %%i in ('ver') do set wos=%%i
if "%wos%"=="6.3.9600" set wos="8.1"
if %description%.==. set description="%date% %time:~0,5% Windows %wos% auf %computername%"
%windir%\system32\dism /%action% /imagefile:%workdir%sources\install.wim /capturedir:%sklw%: /name:"%date:~6,4%-%date:~3,2%-%date:~0,2% %time:~0,5% %computername% %wos%" /description:%description% /checkintegrity /verify /scratchdir:%workdir%
if errorlevel 1 goto ct_error2

echo.
set operation=*** Remove shadow copy again ***
echo. 
echo %operation%
%workdir%%vshadow% -ds=%SHADOW_ID_1%
if errorlevel 1 goto ct_error2

set operation=*** Tell Windows there is a new image ***
if not "%reset%" equ "1" goto ct_next1
echo.
echo.
echo %operation%
set lastindex=0
for /f "tokens=*" %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim ^| find "Index"') do (
  set counter=%%L
  set lastindex=!counter:~8,-1!
)
if %lastindex% equ 0 goto ct_error2
reagentc /setosimage /path %workdir%sources\install.wim /index %lastindex%
if errorlevel 1 goto ct_error2
:ct_next1

set operation=*** Create backup lists ***
%windir%\system32\dism /english /get-wiminfo /wimfile:%workdir%sources\install.wim > %workdir%Backuplists.txt
if errorlevel 1 goto ct_error2

echo.
echo *** Cleaning up ***
set operation=*** Put Windows RE back to its old place ***
reagentc /enable >nul 2>nul
if errorlevel 1 goto ct_error2

set operation=*** Remove RunOnce-key again ***
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
if errorlevel 1 goto ct_error2

set operation=*** And now create the refresh image ***
if not "%refresh%" equ "1" goto ct_next2
echo. 
echo.
echo %operation%
recimg /createimage %workdir%sources
if errorlevel 1 goto ct_error2
:ct_next2

echo.
echo.
echo *** Ready! ***
if "%shutdown%" equ "1" shutdown -s -t 0
pause
goto :eof

rem Requirements not met
:ct_error1
set text=The next requirement is not met: 
goto ct_showerror

rem ct_error during execution
:ct_error2
set text=Execution failed:
goto ct_showerror

:ct_showerror
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
echo %advice%
echo.
echo Cleaning up after myself ...
reagentc /enable >nul 2>nul
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
%workdir%%vshadow% -ds=%SHADOW_ID_1% >nul 2>nul
echo Cleaning ready
pause
goto :eof

rem Cancelled by user
:ct_cancel
echo Cancelled by user
pause
goto :eof

:ct_help
echo.
echo %~nx0 expands the file install.wim with another image 
echo A new one will be created when te file is missing
echo.
echo %~nx0 understands these commandline parameters:
echo   /Reset            - new image is a restore image
echo   /Refresh          - new image is a refresh image
echo   /S                - shutdown Windows after backup
echo   /Shutdown         - shutdown Windows after backup
echo   /D "description"  - use "description" as description for the backup
echo.
echo %~nx0 should be run with administrator rights!
echo.
echo %advice%
echo.
pause
goto :eof
;
REM Created 2014/2015/2016 by Axel Vahldiek (c't) / Noud van Kruysbergen
REM mailto: nkr@fnl.nl

REM Thanks to the users tdklaus and fredo61 for their ideas, 
REM which ended up in this script, as well as others who have helped also!